.\" generated with Ronn-NG/v0.9.1
.\" http://github.com/apjanke/ronn-ng/tree/0.9.1
.TH "ZRAM\-GENERATOR\.CONF" "5" "February 2023" "zram-generator developers"
.SH "NAME"
\fBzram\-generator\.conf\fR \- Systemd unit generator for zram swap devices (configuration)
.SH "SYNOPSIS"
\fB/usr/lib/systemd/zram\-generator\.conf\fR
.br
\fB/usr/local/lib/systemd/zram\-generator\.conf\fR
.br
\fB/etc/systemd/zram\-generator\.conf\fR
.br
\fB/run/systemd/zram\-generator\.conf\fR
.P
\fB/usr/lib/systemd/zram\-generator\.conf\.d/*\.conf\fR
.br
\fB/usr/local/lib/systemd/zram\-generator\.conf\.d/*\.conf\fR
.br
\fB/etc/systemd/zram\-generator\.conf\.d/*\.conf\fR
.br
\fB/run/systemd/zram\-generator\.conf\.d/*\.conf\fR
.SH "DESCRIPTION"
These files configure devices created by zram\-generator(8)\. See systemd\.syntax(5) for a general description of the syntax\.
.SH "CONFIGURATION DIRECTORIES AND PRECEDENCE"
The default configuration doesn\'t specify any devices\. Consult \fI/usr/share/zram\-generator/zram\-generator\.conf\.example\fR for an example configuration file\.
.P
When packages need to customize the configuration, they can install configuration snippets in \fI/usr/lib/systemd/zram\-generator\.conf\.d/\fR\. Files in \fI/etc/\fR are reserved for the local administrator, who may use this logic to override the configuration files installed by vendor packages\. The main configuration file is read before any of the configuration directories, and has the lowest precedence; entries in a file in any configuration directory override entries in the single configuration file\. Files in the \fI*\.conf\.d/\fR configuration subdirectories are sorted by their filename in lexicographic order, regardless of which of the subdirectories they reside in\. When multiple files specify the same option, for options which accept just a single value, the entry in the file with the lexicographically latest name takes precedence\. It is recommended to prefix all filenames in those subdirectories with a two\-digit number and a dash, to simplify the ordering of the files\.
.P
To disable a configuration file supplied by the vendor, the recommended way is to place a symlink to \fI/dev/null\fR in the configuration directory in \fI/etc/\fR, with the same filename as the vendor configuration file\.
.P
The generator understands the following option on the kernel command\-line: \fBsystemd\.zram[=0|1]\fR\. When specified with a true argument (or no argument), the \fBzram0\fR device will be created\. Default options apply, but may be overridden by configuration on disk if present\. When specified with a false argument, no zram devices will be created by the generator\. This option thus has higher priority than the configuration files\.
.SH "OPTIONS"
Each device is configured independently in its \fB[zramN]\fR section, where N is a nonnegative integer\. Other sections are ignored\.
.P
Devices with the final size of \fI0\fR will be discarded\.
.IP "\[ci]" 4
\fBhost\-memory\-limit\fR=
.IP
Sets the upper limit on the total usable RAM (as defined by \fIMemTotal\fR in \fB/proc/meminfo\fR, confer proc(5)) above which the device will \fInot\fR be created\.
.IP
This takes a nonnegative number, representing that limit in megabytes, or the literal string \fInone\fR, which can be used to override a limit set earlier\.
.IP
Defaults to \fInone\fR\.
.IP "\[ci]" 4
\fBzram\-size\fR=
.IP
Sets the size of the zram device as a function of \fIMemTotal\fR, available as the \fBram\fR variable\.
.IP
Arithmetic operators (^%/*\-+), e, π, SI suffixes, log(), int(), ceil(), floor(), round(), abs(), min(), max(), and trigonometric functions are supported\.
.IP
Defaults to \fImin(ram / 2, 4096)\fR\.
.IP "\[ci]" 4
\fBcompression\-algorithm\fR=
.IP
Specifies the algorithm used to compress the zram device\.
.IP
This takes a literal string, representing the algorithm to use\.
.br
Consult \fI/sys/block/zram0/comp_algorithm\fR for a list of currently loaded compression algorithms, but note that additional ones may be loaded on demand\.
.IP
If unset, none will be configured and the kernel\'s default will be used\.
.IP "\[ci]" 4
\fBwriteback\-device\fR=
.IP
Write incompressible pages, for which no gain was achieved, to the specified device under memory pressure\. This corresponds to the \fI/sys/block/zramX/backing_dev\fR parameter\.
.IP
Takes a path to a block device, like \fI/dev/disk/by\-partuuid/2d54ffa0\-01\fR or \fI/dev/zvol/tarta\-zoot/swap\-writeback\fR\.
.IP
If unset, none is used, and incompressible pages are kept in RAM\.
.IP "\[ci]" 4
\fBswap\-priority\fR=
.IP
Controls the relative swap priority, a value between \-1 and 32767\. Higher numbers indicate higher priority\.
.IP
If unset, 100 is used\.
.IP "\[ci]" 4
\fBmount\-point\fR=
.IP
Format the device with a file system (not as swap) and mount this file system over the specified directory\. When neither this option nor \fBfs\-type\fR= is specified, the device will be formatted as swap\.
.IP
Note that the device is temporary: contents will be destroyed automatically after the file system is unmounted (to release the backing memory)\.
.IP "\[ci]" 4
\fBfs\-type\fR=
.IP
Specifies how the device shall be formatted\. The default is \fIext2\fR if \fBmount\-point\fR is specified, and \fIswap\fR otherwise\. (Effectively, the device will be formatted as swap, if neither \fBfs\-type\fR= nor \fBmount\-point\fR= are specified\.)
.IP
Note that the device is temporary: contents will be destroyed automatically after the file system is unmounted (to release the backing memory)\.
.IP
Also see systemd\-makefs(8)\.
.IP "\[ci]" 4
\fBoptions\fR=
.IP
Sets mount or swapon options\. Availability depends on \fBfs\-type\fR\.
.IP
Defaults to \fIdiscard\fR\.
.IP "" 0
.SH "ENVIRONMENT VARIABLES"
Setting \fBZRAM_GENERATOR_ROOT\fR during parsing will cause \fI/proc/meminfo\fR to be read from \fI$ZRAM_GENERATOR_ROOT/proc/meminfo\fR instead, and \fI{/usr/lib,/usr/local/lib,/etc,/run}/systemd/zram\-generator\.conf\fR to be read from \fI$ZRAM_GENERATOR_ROOT/{/usr/lib,/usr/local/lib,/etc,/run}/systemd/zram\-generator\.conf\fR\.
.SH "EXAMPLES"
The default configuration will yield the following:
.IP "" 4
.nf
 zram device size
     ^
     │
  4G>│               ooooooooooooo
     │             o
     │           o
     │         o
  2G>│       o
     │     o
     │   o
512M>│ o
     0───────────────────────> total usable RAM
       ^     ^       ^
       1G    4G      8G
.fi
.IP "" 0
.P
A piecewise\-linear size 1:1 for the first 4G, then 1:2 above, up to a max of 32G:
.br
\~\~\fBzram\-size = min(min(ram, 4096) + max(ram \- 4096, 0) / 2, 32 * 1024)\fR
.IP "" 4
.nf
 zram device size
     ^
 32G>|                                                oooooooooooooo
     |                                            o
 30G>|                                        o
     |
    /=/
     |
  8G>│                           o
     │                       o
     │                   o
     │               o
     │           o
  4G>│       o
     │     o
     │   o
  1G>│ o
     0───────────────────────────────────||──────────────────────> total usable RAM
       ^     ^       ^               ^        ^       ^       ^
       1G    4G      8G             12G      56G     60G     64G
.fi
.IP "" 0
.SH "OBSOLETE OPTIONS"
.IP "\[ci]" 4
\fBmemory\-limit\fR=
.IP
Compatibility alias for \fBhost\-memory\-limit\fR\.
.IP "\[ci]" 4
\fBzram\-fraction\fR=
.IP
Defines the scaling factor of the zram device\'s size with relation to the total usable RAM\.
.IP
This takes a nonnegative floating\-point number representing that factor\.
.IP
Defaulted to \fI0\.5\fR\. Setting this or \fBmax\-zram\-size\fR overrides \fBzram\-size\fR\.
.IP "\[ci]" 4
\fBmax\-zram\-size\fR=
.IP
Sets the limit on the zram device\'s size obtained by \fBzram\-fraction\fR\.
.IP
This takes a nonnegative number, representing that limit in megabytes, or the literal string \fInone\fR, which can be used to override a limit set earlier\.
.IP
Defaulted to \fI4096\fR\. Setting this or \fBzram\-fraction\fR overrides \fBzram\-size\fR\.
.IP "" 0
.SH "REPORTING BUGS"
\fIhttps://github\.com/systemd/zram\-generator/issues\fR
.SH "SEE ALSO"
zram\-generator(8), systemd\.syntax(5), proc(5)
.P
\fIhttps://github\.com/systemd/zram\-generator\fR
.P
Linux documentation of zram: \fIhttps://kernel\.org/doc/html/latest/admin\-guide/blockdev/zram\.html\fR
.br
and the zram sysfs ABI: \fIhttps://kernel\.org/doc/Documentation/ABI/testing/sysfs\-block\-zram\fR
.P
\fBfasteval\fR documentation for the entire \fBzram\-size\fR arithmetic DSL: \fIhttps://docs\.rs/fasteval/0\.2\.4/fasteval/#the\-fasteval\-expression\-mini\-language\fR
